#ifndef __RC_MOSAIC_VMS_DEFS

#	define __RC_MOSAIC_VMS_DEFS 1

#	include <types.h>	/* common type definitions */
#	include <socket.h>	/* Socket stuff */
#	include <in.h>		/* Internet defs */
#	include <netdb.h>	/* More net defs */
#	include <ucx$inetdef.h>	/* UCX interface to inet stuff */
#	include <unixio.h>	/* delete(), access(), ... */
#	include <unixlib.h>	/* getpid() */
#	include <processes.h>	/* vfork(), execlp(), ... */
#	include <descrip.h>	/* VMS descriptors and $DESCRIPTOR macro */
#	include <iodef.h>	/* IO$ functions for SYS$QIOW() call */
#	include <jpidef.h>	/* $GETJPI symbols */
#	include <lnmdef.h>	/* $TRNLNM symbols */

/* Item_list_3 structure */

typedef struct
{
   short buflen;
   short item_code;
   int *buf_addr;
   int *len_addr;
} item_list_3;

	extern int sys$dclexh();		/* Declare exit handler */
	extern int sys$waitfr();		/* Wait for event flag */
	extern int sys$getjpiw();		/* $GETJPI - job/process info */
	extern int sys$suspnd();		/* Suspend process */
	extern int lib$spawn(); 		/* Spawn a sub process */
	extern int lib$set_logical();		/* Set a logical name */
	extern int lib$delete_logical();	/* Delete a logical name */
	extern int lib$signal();		/* Exit w/ condition handler */
	extern int sys$trnlnm();		/* Translate logical name */
	extern int sys$assign();		/* Assign channel to mailbox */
	extern int sys$dassgn();		/* Deassign channel */
	extern int sys$qiow();			/* Low level queued I/O call */
	unsigned long spawn_flag = 0x00000001;	/* NOWAIT - parent goes on */
	unsigned char spawn_ef = SIGCHLD;	/* Event flag to mark death */
	static char username[13];		/* Username */
	static char log_buffer[256],		/* Logical name to translate */
		    val_buffer[256],		/* Equivalence name */
		    spawn_buff[80];		/* SPAWN command buffer */
	static int usrlen;			/* Length of username */
	static int retstat;			/* Service return status */
	static int attr = LNM$M_CASE_BLIND;	/* Attribute for $TRNLNM */
	static int namlen;			/* Length of transled name */
	static int i;				/* Index for username buffer */
	short int prot_mask = 0x0000;		/* Allow everyone access */
	unsigned short	chan;			/* Access channel */
	unsigned int	func;			/* IO$ function for $qiow call*/


	static item_list_3 itmlst[2] = {	/* Item list for $GETJPI */
		{12, JPI$_USERNAME, (int *)&username, &usrlen},
		{0, 0, 0, 0}	};
	static item_list_3 lnm_itmlst[2] = {	/* Item list for $TRNLNM */
		{255, LNM$_STRING, (int *)&val_buffer, &namlen},
		{0, 0, 0, 0}	};


        /* You need GRPNAM privilege to use the -mbx_grp option */
	/* This defines the logical name for the mailbox, MOSAIC_<username>, */
	/* in your group logical name table.  Way cool.  So you can just:    */
	/* 	$ open/write mbx MOSAIC_SYSOP				     */
	/* 	$ write mbx "newwin|URL"				     */
	/*	$ close mbx						     */
	/* etc, from any process within the same group.  Killer!	     */
	/*								     */
	/* VMS control commands as of version 2.4-2:			     */
	/* 	goto|<URL>, newwin|<URL>, pagedown, pageup, scrolldown,	     */
	/* 	scrollup, flushimagecache, backnode, forwardnode,	     */
	/*	reloaddocument, reloadimages, refresh, iconify, deiconify,   */
	/*	raise, move, resize			    		     */
	/*								     */
	/* The goto and newwin commands must be followed by a vertical 	     */
	/* bar and then the URL of the page to display.			     */
	/*								     */
	/* Commands to be added in subsequent versions:			     */
	/*	iconify, deiconify, raise, move, resize			     */


$DESCRIPTOR(spawn_cmd, spawn_buff);
$DESCRIPTOR(spawn_inp, MOSAIC_CMD);
$DESCRIPTOR(spawn_nul, "NL:");
$DESCRIPTOR(display, "DECW$DISPLAY");	/* The primary X display	 */
$DESCRIPTOR(rc_manager, "RC_MANAGER");	/* The presentation manager display */
$DESCRIPTOR(rc_display, "RC_DISPLAY");	/* The display of the client	 */
$DESCRIPTOR(logical, log_buffer);	/* See SYS$LIBRARY:DESCRIP.H for */
$DESCRIPTOR(value, val_buffer);		/* the $DESCRIPTOR macro.	 */
$DESCRIPTOR(mbox, val_buffer);		/* Descriptor to the mailbox */
$DESCRIPTOR(table, "LNM$DCL_LOGICAL");	/* Use LNM$PROCESS for process table */
					/* LNM$JOB for job table, and */
					/* LNM$FILE_DEV or LNM$DCL_LOGICAL */
					/* all of the user's logical tables */

/* Routine to declare an exit handler */

declare_exit_handler()
{
        static unsigned int exit_status_addr;
        static struct {
          unsigned int exit_l_forw;
          unsigned int exit_a_addr;
          unsigned int exit_l_argc;
          unsigned int exit_a_stat;
          unsigned int exit_l_arg1;
        } exitblk;

        exitblk.exit_l_forw = 0;
        exitblk.exit_a_addr = (unsigned int) sigchld_handler;
        exitblk.exit_l_argc = 1;
        exitblk.exit_a_stat = (unsigned int) &exit_status_addr;
	exitblk.exit_l_arg1 = 1;
        sys$dclexh( &exitblk );
}

#endif
